import httpClient from "../utils/request";

interface AddFinanceForm {
  date?: string;
  type?: string;
  event?: string;
  amount?: number;
  oppositeCompany?: string;
}

export const addFinance = (data: AddFinanceForm) =>
  httpClient.request({
    url: "/mini-app/finance/detail",
    method: "POST",
    data,
  });

interface QueryParams {
  oppositeCompany?: string;
  pageSize: number;
  pageNum: number;
}
export const getFinanceList = (params: QueryParams) =>
  httpClient.request({
    url: "/mini-app/finance/detail/list",
    params,
  });

export const getFinanceInfo = (financeId: string) =>
  httpClient.request({
    url: `/mini-app/finance/detail/${financeId}`,
  });
interface UpdateFinanceForm {
  financeId?: string;
  date?: string;
  type?: string;
  event?: string;
  amount?: number;
  oppositeCompany?: string;
}
export const updateFinance = (data: UpdateFinanceForm) =>
  httpClient.request({
    url: "/mini-app/finance/detail",
    method: "PUT",
    data,
  });

export const deleteFinance = (financeIds: string) =>
  httpClient.request({
    url: `/mini-app/finance/detail/${financeIds}`,
    method: "DELETE",
  });

export const getStatistics = () =>
  httpClient.request({
    url: "/mini-app/finance/detail/statistics",
  });
